Developer Relations quarterly goals for October-December 2015
Closed, ResolvedPublic

Description

Previous: T101100: Engineering Community quarterly goals for July-September 2015
Next: T119388: Developer Relations quarterly goals for January - March 2016

Let's discuss the goals of the Developer-Relations team for the next quarter. There is some inspiration at T101099: Developer Relations Roadmap and the Developer-Relations workboard.

NOTE: unstable draft, changes are likely to happen.

Team goals

GoalMeasurement of successDependencyETAStatus
T113685: Successful organization of the Wikimedia Developer Summit 2016 (STRENGTHEN)Logistics of a 3 day event in 2 locations are all solved. The schedule reflects WMF Engineering priorities. Scheduled sessions are preceded by online discussions involving their stakeholders. 25% of registration are volunteers or third party developers.Architecture, Engineering, Strategic Partnerships, Comms, Community TechDevRel-December-2015Drafting
T101686: Goal: Define potential actions to reduce code review queues and waiting times (STRENGTHEN)Identify potential actions for WMF Engineering to address the code review queue of changesets submitted by volunteers (to propose and discuss with Eng teams, Team-Practices and volunteer maintainers in Q1/2016)Cleanup day participants; research papersDevRel-December-2015Doing; to excerpt 3-5 non-trivial potential actions before T114419 session at WikiDev Summit; T78768 as followup
T114017: Map current use of Wikimedia web APIs (FOCUS)List of known users of Wikimedia web APIs specifying main uses. Metrics of quantitative use of these APIsReading Product Management, Reading Infrastructure, Services, Strategic Partnerships, T102079: Metrics about the use of the Wikimedia web APIsDevRel-December-2015Drafting
T90908: Goal: Binding code of conduct for all Wikimedia technical spaces with consequences for breaches (FOCUS)Code of Conduct for technical spaces approved, committee created@mattflaschen @Fhocutt Support-and-SafetyDevRel-December-2015Drafting
T112267: Goal: Organize the start of Outreachy round 11 (EXPERIMENT)Organization driven by volunteers. 5 featured project ideas. Selection process completed and documented.Volunteer org admins and mentorsDevRel-November-2015Drafting

Individual goals

@Aklapper

GoalMeasurement of successDependencyETAStatus
T101686: Goal: Define potential actions to reduce code review queues and waiting times (FOCUS)Summarized findings of Gerrit Cleanup Day and paper research; identified actionable items which help shorten the code review backlogCleanup day participants; research papersDevRel-November-2015, DevRel-December-2015, DevRel-January-2016Doing; to excerpt 3-5 non-trivial potential actions before T114419 session at WikiDev Summit; incorporate decisions from T114419 into it in January; T78768 as followup
T111520: Organize and coordinate Wikimedia's participation in Google Code-In 2015 (STRENGTHEN)Successful participation with >25 mentors and >200 tasks finishedCommunity member(s) help organizing; community members to be potential mentorsDevRel-October-2015, DevRel-November-2015, DevRel-December-2015, DevRel-January-2016Doing; On 2015-12-29 we have 31 mentors with at least one task and 141 (non-trivial) tasks resolved; Nemo_bis and Petan co-organizing

@Qgil

T90908: Goal: Binding code of conduct for all Wikimedia technical spaces with consequences for breachesCode of Conduct for technical spaces approved, committee createdsee team goals
T116025: Goal: Align Community Liaison and Developer Relations project management practicesComing soonCE teamsDevRel-November-2015Drafting
T110170: Goal: Deploy Newsletter extension in WikimediaNewsletter extension enabled in one Wikimedia project#Newsletter-extension project volunteersDevRel-December-2015Drafting

@Rfarrand

GoalMeasurement of successDependencyETAStatus
[T111799] Wikimedia Developer Summit 2016 Logistics EXPERIMENTAll contracts are signed and down payments are made. Meeting room logistics are confirmed. Food and social events are planned.Mission Bay Center, WikiDev16 Content planning team, cateringEnd of quarterIn progress
[T104347] Plan for Engineering Travel Approvals to Wikimedia Hackathon 2016 and Wikimania Hackathon 2016 (Jerusalem) STRENGTHENAgreement and people are able to start planning budgets and travelWMIS, Engineering Management, WMF Travel, Wikimedia teamEnd of quarterIn progress

@Spage

GoalMeasurement of successDependencyETAStatus
T114017 (FOCUS)See Team goals aboveThinking
T115933: Write four showcase/inspire articles for the Web APIs hub (STRENGTHEN)Meet needs of developerspriorities from API mapping, WMF devs reviewingend of quarterstuff in progress
mentor Outreachy proposal for T91626: Technology to transclude git content into wiki pagesit's accepted for Outreachy-Round-11interested Candidates
T104286: Engage developer documentation task force (FOCUS)Drafting

Related Objects

There are a very large number of changes, so older changes are hidden. Show Older Changes
Qgil raised the priority of this task from Low to High.Sep 1 2015, 7:08 AM
Qgil moved this task from Backlog to Doing on the DevRel-September-2015 board.Sep 1 2015, 12:40 PM
Aklapper updated the task description. (Show Details)Sep 1 2015, 2:10 PM
Johan edited projects, added Developer-notice; removed Notice.Sep 3 2015, 3:08 PM
Qgil added a comment.EditedSep 4 2015, 7:40 AM

@Aklapper, I'm thinking that the code review queue related goal should be your main contribution to the ECT quarterly goals, while the Google Code-in goal could be an individual goal. Let me explain.

So far in ECT's roadmap we are betting for a sequence of code review performance goals that would lead to a Service Level Agreement by the end of June 2016. This is a bold change that would have a big impact in our technical community, it requires continuous focused attention and well defined milestones along the way. It is also a social process involving literally hundreds of developers, volunteers and employed.

Google Code-in is very important, and keeping the good performance of our previous editions is not simple at all. However, it is also a well framed project where others can get involved easily. Google sets the rules and provides the platform, and we have a machine that theoretically works with easy bugs and a list of people that already have experience mentoring in the context of this program. Also, just like GSoC and Outreachy have done steps being less dependent on ECT's leadership, the same can be said about Google Code-in. By making Google Code-in not a quarterly ECT project but @Aklapper's quarterly goal, I believe that in fact we are contributing to empower the community to get more involved in this program and get the most of it for their own benefit. Besides, I'm thinking that we could get Community-Tech and related volunteers involved, opening a vein of small tasks benefiting gadgets, templates, tool, and the likes.

Driving the reduction of code review waiting times is complex, a long-term game, and someone with part/full time dedication with a foot inside the WMF is basically required to lead this effort successfully. Google Code-in can be a great success without our direct lead.

Note also that Release-Engineering-Team is planning to have a goal around Gerrit-Migration during this quarter (see T110623 & T584), which is another reason to think that it is a good time to keep pushing the pedal to the metal on this topic, right after Gerrit Cleanup Day.

Thoughts?

(Edited) And about T78639: How to address the long tail of low priority tasks in active projects and you not being sure this is a problem, then the action to take is to clarify that first, and either Decline the task or make it a priority at some point, don't you think? Currently it looks like a weak goal.

Qgil updated the task description. (Show Details)Sep 4 2015, 8:17 AM
Qgil added subscribers: Fhocutt, Mattflaschen-WMF.
Qgil added a comment.Sep 4 2015, 9:32 AM

I updated the description proposing four team goals, some of them to be properly defined, all of them to be confirmed. I have pinged potential stakeholder in related tasks or via email. How does that look?

Community Engagement team must provide a first draft of our team goals by 10 September, next Thursday. I will propose whatever is the current version of this description by then. Only team goals, not individual ones.

Aklapper updated the task description. (Show Details)Sep 4 2015, 1:34 PM
Aklapper updated the task description. (Show Details)Sep 4 2015, 1:41 PM

[...] it requires continuous focused attention and well defined milestones along the way. It is also a social process involving literally hundreds of developers, volunteers and employed. [...] Driving the reduction of code review waiting times is complex, a long-term game, and someone with part/full time dedication with a foot inside the WMF is basically required to lead this effort successfully.

Quim, these are very good and convincing points that I agree with. Thank you for sharing them.
The "well defined milestones" part will be an interesting challenge.

ThurnerRupert added a subscriber: ThurnerRupert.EditedSep 5 2015, 10:03 PM

defining a code of conduct as an _engineering goal_ is just wrong, and waste in the agile sense. besides it is not engineering, there is no benefit to the client. additionally this is targeted to anglo-saxon case law, complicating the user experience for everybody else.

Qgil added a comment.Sep 6 2015, 12:07 PM

@ThurnerRupert, what we are discussing here are goals of the Engineering Community team. A main purpose of this team is to promote community health, and therefore a goal related to a Code of Conduct is definitely within scope.

About "targeted to anglo-saxon case law", I'm curious about your reasoning as one of the main contributors to the draft and as a not-anglo-saxon-anything myself. But please, elaborate at the Draft discussion page not to spread even more the CoC discussion. Thank you.

Qgil updated the task description. (Show Details)Sep 10 2015, 2:02 PM
Qgil updated the task description. (Show Details)Sep 11 2015, 7:06 AM
Qgil added subscribers: SVentura, kaldari, bd808 and 6 others.EditedSep 11 2015, 7:26 AM

@Rfarrand, check the goal I'm proposing for the Summit. Bringing volunteers and third party developers is a goal consistent with the Developer Relations focus, and it is also the main novelty that requires especial attention. The rest (logistics, program, is very complex and brings a lot more work, but it is also more predictable and something we know we can do. In order to succeed in this goal we will need the involvement of Strategic Partnerships, the teams involved in API development, the MediaWiki Stakeholders Group, Labs, Community Tech, and ideally the TCB-Team.

According to the registration, in the last Summit we had 19 non-WMF non-WMDE participants out of of 150 (12.7%). What about defining a goal of 25% this year? When it comes to sessions it is not easy to count, but there were about 6 sessions out of 38 (15.7%) that were initiated by non-WMF non-WMDE participants or focused on 3rd party topics. Should we aim to 20%?

@Spage, after our conversations this week I think we need a goal to nail down the question of who is using our web APIs and to do what, with the best of our knowledge based on contacts, memory, and metrics. This work will support possible tasks we are discussing like a SF meetup to record a Wikimedia APIs intro tutorial, a survey for developers using our APIs, and the invitation of the right people to the Summit.

What do you think? Sorry for the wide CC but as you can see we are inviting you to have a share on our goals (that could be part of your goals as well).

Qgil updated the task description. (Show Details)Sep 11 2015, 2:31 PM
Qgil renamed this task from Engineering Community quarterly goals for October-December 2015 to Developer Relations quarterly goals for October-December 2015.Sep 13 2015, 12:56 PM
Qgil updated the task description. (Show Details)
Rfarrand updated the task description. (Show Details)Sep 15 2015, 3:56 PM
Rfarrand updated the task description. (Show Details)
Spage updated the task description. (Show Details)Sep 15 2015, 6:42 PM
Spage updated the task description. (Show Details)Sep 16 2015, 1:39 AM
Spage added a subscriber: yuvipanda.
Qgil added a comment.Sep 16 2015, 7:48 AM

@Rfarrand, I still think that we should have a goal about the overall organization of the Summit, not only the logistics. Based in our discussions in the past two days, what about this:

  • Goal: Successful planning of the Wikimedia Developer Summit 2016
  • Measurement of success:
    • All logistics ready, addressing the lessons learned in 2015.
    • A schedule with sessions following the areas of focus and the online discussion process.
    • 25% of registered participants not affiliated with WMF or WMDE.

@Spage, please create a task for Mapping current use of Wikimedia web APIs

Qgil updated the task description. (Show Details)Sep 16 2015, 8:00 AM
Qgil updated the task description. (Show Details)Sep 16 2015, 8:11 AM
Qgil added a comment.Sep 16 2015, 8:15 AM

I have added T112267: Goal: Organize the start of Outreachy round 11 to our team goals as agreed yesterday in our team meeting. I am not adding T111520: Organize and coordinate Wikimedia's participation in Google Code-In 2015 because I'm reluctant of adding a 6th goal, but also because it is not in our hand to complete this goal. Google invites the organizations that participate in Google Code-in and (contrary to Google Summer of Code) the number of orgs accepted is very small. We have been accepted two years, but there is no guarantee that we will be accepted again.

@Aklapper, do you think this compromise is reasonable?

@Aklapper, do you think this compromise is reasonable?

Yes.

Rfarrand updated the task description. (Show Details)Sep 24 2015, 1:54 AM
Qgil updated the task description. (Show Details)Sep 24 2015, 12:35 PM

@Rfarrand, I have updated the measures of success of the Summit planning based on our conversation earlier this week. Please create a task to track this goal.

@Spage, please create also a task to track the goal about mapping web APIs.

Rfarrand updated the task description. (Show Details)Sep 24 2015, 11:39 PM
Rfarrand updated the task description. (Show Details)
Spage updated the task description. (Show Details)Sep 28 2015, 8:10 PM
Qgil lowered the priority of this task from High to Low.Oct 13 2015, 4:16 PM

Alright, these are our goals now. Changing the priority of this task to Business as Usual, aka Low.

Spage updated the task description. (Show Details)Oct 13 2015, 5:59 PM
Qgil updated the task description. (Show Details)Oct 20 2015, 3:48 PM

My second goal was initially planned as "Plan for adoption of Phabricator across WMF Community Engagement teams". However, that is a big bite, I have other big bites to solve this quarter, and it looks like it is being a busy quarter. Therefore, I'm narrowing scope into a more tangible and specific goal: T116025: Goal: Align Community Liaison and Developer Relations project management practices.

Rfarrand updated the task description. (Show Details)Oct 20 2015, 5:48 PM
Rfarrand updated the task description. (Show Details)Oct 20 2015, 5:52 PM
Rfarrand updated the task description. (Show Details)
Rfarrand updated the task description. (Show Details)Oct 20 2015, 5:55 PM
Rfarrand updated the task description. (Show Details)
Spage updated the task description. (Show Details)Oct 20 2015, 6:09 PM
Spage updated the task description. (Show Details)Oct 20 2015, 6:30 PM
Aklapper updated the task description. (Show Details)Dec 3 2015, 4:11 PM
Aklapper updated the task description. (Show Details)Dec 3 2015, 4:24 PM
Aklapper updated the task description. (Show Details)Dec 3 2015, 4:36 PM
Aklapper updated the task description. (Show Details)Dec 29 2015, 5:54 PM
Aklapper updated the task description. (Show Details)
Rfarrand updated the task description. (Show Details)Dec 29 2015, 6:47 PM
Qgil raised the priority of this task from Low to High.Jan 12 2016, 1:34 AM

Our quarterly review calendar:

  • 12 Jan: draft slides ready for review.
  • 14 Jan: practice run.
  • 19 Jan: quarterly review.
Qgil moved this task from Backlog to Doing on the DevRel-January-2016 board.Jan 12 2016, 1:49 AM
Aklapper updated the task description. (Show Details)Jan 19 2016, 7:45 PM
Aklapper added a subscriber: Mattflaschen-WMF.
Qgil lowered the priority of this task from High to Low.Jan 20 2016, 11:05 AM

The quarterly review was completed yesterday. The very short summary is: a decent quarter, even if we missed some factor in 4 out of 5 goals.

  • The Summit was successful and better than last years, but we missed a higher % of non-WMF participants.
  • Code review plan: we opted to wait for the Summit, where this was an important topic, hence missing the deadline.
  • Use of Wikimedia APIs, yes, this is a full miss, but we simply lacked the resources to work on it.
  • Code of Conduct, it is progressing slower than we expected but in a good direction. No regrets.
  • Outreachy lead by volunteers: SUCCESS!

I will post the link to notes and slides when available.